/*
 *  Copyright (c) 1998-2007, The University of Sheffield.
 *
 *  This file is part of GATE (see http://gate.ac.uk/), and is free
 *  software, licenced under the GNU Library General Public License,
 *  Version 2, June 1991 (in the distribution as file licence.html,
 *  and also available at http://gate.ac.uk/gate/licence.html).
 *
 *  Valentin Tablan 02/10/2001
 *
 *  $Id: OffsetComparator.java 8929 2007-07-12 16:49:55Z ian_roberts $
 *
 */
package gate.util;

import java.util.Comparator;

import gate.Annotation;

/**
 * Compares annotations by start offset
 */
public class OffsetComparator implements Comparator {

  public int compare(Object o1, Object o2){
    Annotation a1 = (Annotation)o1;
    Annotation a2 = (Annotation)o2;
    int result;

    // compare start offsets
    result = a1.getStartNode().getOffset().compareTo(
        a2.getStartNode().getOffset());

    // if start offsets are equal compare end offsets
    if(result == 0) {
      result = a1.getEndNode().getOffset().compareTo(
          a2.getEndNode().getOffset());
    } // if

    return result;
  }
}